Bug 830784 - Review Request: leiningen - Clojure project automation tool
Review Request: leiningen - Clojure project automation tool
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michael Scherer
Fedora Extras Quality Assurance
:
Depends On: 830287 830398 830709 830777 830933
Blocks: 830714
  Show dependency treegraph
 
Reported: 2012-06-11 08:19 EDT by Michel Alexandre Salim
Modified: 2012-12-20 11:04 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-12-20 11:04:54 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
misc: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Michel Alexandre Salim 2012-06-11 08:19:59 EDT
Spec URL: http://salimma.fedorapeople.org/specs/clojure/leiningen.spec
SRPM URL: http://salimma.fedorapeople.org/specs/clojure/leiningen-1.7.1-1.fc17.src.rpm
Description: 
Working on Clojure projects with tools designed for Java can be an
exercise in frustration. With Leiningen, you describe your build with
Clojure. Leiningen handles fetching dependencies, running tests,
packaging your projects and can be easily extended with a number of
plugins.

Fedora Account System Username: salimma
Comment 1 Michel Alexandre Salim 2012-06-11 11:30:25 EDT
Not ready yet - launcher script is still in progress, and there are some dependencies still missing
Comment 2 Michel Alexandre Salim 2012-06-11 13:28:32 EDT
maven-artifact from Maven 3 seems to be missing AbstractArtifactMetadata which is needed by either maven-artifact-manager or something else (not sure which, but it's pulled in when invoking 'lein')

Filed bug against maven2 (asking for its maven-artifact to be packaged) and blocking this review on that bug report
Comment 3 Michel Alexandre Salim 2012-06-11 22:36:24 EDT
Spec URL: http://salimma.fedorapeople.org/specs/clojure/leiningen.spec
SRPM URL: http://salimma.fedorapeople.org/specs/clojure/leiningen-1.7.1-2.fc17.src.rpm

Now ready for review; note that you'd need to install the dependencies currently under review yourself (the blocked-by list), and also rebuild maven2 (see the attached patch on #830933) and install the generated maven-settings and maven-artifact RPMs
Comment 4 Michael Scherer 2012-07-29 07:54:49 EDT
There is a few issues :

%global vendor define the vendor tag by error, and this is forbidden, so i think the easiest fix is to rename it ( https://fedoraproject.org/wiki/Packaging:Guidelines#Tags )


The test are not run at build time, is there a reason ( like "it need network" ) ?


The package is also not installable on f17, so I didn't test it yet, and there is various maven related issue, and for that, i need to read and digest the java /maven policy. 



Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package contains desktop file if it is a GUI application.
[x]: MUST Development files must be in a -devel package
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Package complies to the Packaging Guidelines
[!]: MUST Spec file lacks Packager, Vendor, PreReq tags.
     Note: Found : Vendor: technomancy
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[x]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
[x]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[-]: MUST If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[!]: MUST Package installs properly.
     Note: Installation errors (see attachment)
[x]: MUST Package is not relocatable.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[x]: SHOULD Reviewer should test that the package builds in mock.
[-]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[ ]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SHOULD Scriptlets must be sane, if used.
[x]: SHOULD SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[!]: SHOULD SourceX / PatchY prefixed with %{name}.
     Note: Source0 (technomancy-leiningen-1.7.1-0-g713a4d9.tar.gz)
[x]: SHOULD SourceX is a working URL.
[x]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[!]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.


==== Java ====
[x]: MUST If source tarball includes bundled jar/class files these need to be
     removed prior to building
[x]: MUST Packages have proper BuildRequires/Requires on jpackage-utils
[x]: MUST Fully versioned dependency in subpackages, if present.
[-]: MUST Javadoc documentation files are generated and included in -javadoc
     subpackage
     Note: No javadoc subpackage present
[-]: MUST Javadoc subpackages have Requires: jpackage-utils
[-]: MUST Javadocs are placed in %{_javadocdir}/%{name} (no -%{version}
     symlink)
     Note: No javadoc subpackage present
[x]: SHOULD Package has BuildArch: noarch (if possible)
[ ]: SHOULD Package uses upstream build method (ant/maven/etc.)


==== Maven ====
[ ]: MUST Pom files have correct add_maven_depmap call
     Note: Some add_maven_depmap calls found. Please check if they are correct
[!]: MUST Old add_to_maven_depmap macro is not being used
[!]: MUST Packages DOES NOT have Requires(post) and Requires(postun) on
     jpackage-utils for %update_maven_depmap macro
[ ]: MUST If package contains pom.xml files install it (including depmaps)
     even when building with ant
[!]: MUST Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: MUST Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms

Issues:
[!]: MUST Package installs properly.
     Note: Installation errors (see attachment)
See: https://fedoraproject.org/wiki/Packaging:Guidelines
[!]: MUST Spec file lacks Packager, Vendor, PreReq tags.
     Note: Found : Vendor: technomancy
See: None
[!]: MUST Old add_to_maven_depmap macro is not being used
See: https://fedoraproject.org/wiki/Packaging:Java#add_maven_depmap_macro
[!]: MUST Packages DOES NOT have Requires(post) and Requires(postun) on
     jpackage-utils for %update_maven_depmap macro
See: https://fedoraproject.org/wiki/Packaging:Java
[!]: MUST Package DOES NOT use %update_maven_depmap in %post/%postun
See: https://fedoraproject.org/wiki/Packaging:Java#add_maven_depmap_macro
[!]: SHOULD %check is present and all tests pass.

Installation errors
-------------------
INFO: mock.py version 1.1.23 starting...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Mock Version: 1.1.23
INFO: Mock Version: 1.1.23
Start: lock buildroot
INFO: installing package(s): /home/misc/checkout/git/FedoraReview/830784-leiningen/results/leiningen-1.7.1-2.fc17.noarch.rpm
ERROR: Command failed: 
 # ['/usr/bin/yum', '--installroot', '/var/lib/mock/fedora-17-x86_64/root/', 'install', '/home/misc/checkout/git/FedoraReview/830784-leiningen/results/leiningen-1.7.1-2.fc17.noarch.rpm', '--setopt=tsflags=nocontexts']
Erreur : Paquet : leiningen-1.7.1-2.fc17.noarch (/leiningen-1.7.1-2.fc17.noarch)
             Requiert : maven-artifact
 Vous pouvez essayer d'utiliser --skip-broken pour contourner le problème
Erreur : Paquet : leiningen-1.7.1-2.fc17.noarch (/leiningen-1.7.1-2.fc17.noarch)
             Requiert : maven-settings
 Vous pouvez essayer d'exécuter : rpm -Va --nofiles --nodigest

Rpmlint
-------
Checking: leiningen-1.7.1-2.fc17.noarch.rpm
          leiningen-1.7.1-2.fc17.src.rpm
leiningen.noarch: E: devel-dependency java-devel
leiningen.noarch: W: spelling-error Summary(en_US) Clojure -> Closure, Cloture, Conjure
leiningen.noarch: W: non-conffile-in-etc /etc/bash_completion.d/lein
leiningen.noarch: W: no-manual-page-for-binary lein
leiningen.src: W: spelling-error Summary(en_US) Clojure -> Closure, Cloture, Conjure
leiningen.src: W: invalid-url Source0: technomancy-leiningen-1.7.1-0-g713a4d9.tar.gz
2 packages and 0 specfiles checked; 1 errors, 5 warnings.


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:
Requires
--------
leiningen-1.7.1-2.fc17.noarch.rpm (rpmlib, GLIBC filtered):
    
    /bin/bash  
    ant  
    classworlds  
    clojure-compat  
    clojure-contrib  
    clucy  
    java-devel  
    jline  
    jpackage-utils  
    lancet  
    maven-ant-tasks  
    maven-artifact  
    maven-error-diagnostics  
    maven-settings  
    rlwrap  
    robert-hooke  

Provides
--------
leiningen-1.7.1-2.fc17.noarch.rpm:
    
    leiningen = 1.7.1-2.fc17
    mvn(leiningen:leiningen)  

MD5-sum check
-------------


Generated by fedora-review 0.2.0 (a5c4ced) last change: 2012-07-22
Command line :./try-fedora-review -b 830784
External plugins:
Comment 5 Michel Alexandre Salim 2012-08-03 05:13:48 EDT
(In reply to comment #4)
> There is a few issues :
> 
> %global vendor define the vendor tag by error, and this is forbidden, so i
> think the easiest fix is to rename it (
> https://fedoraproject.org/wiki/Packaging:Guidelines#Tags )
> 
Yup, we've renamed that tag in our other packages to upstream, this one hasn't been touched yet since we were waiting on a fix for the Maven package. Sadly the Maven maintainer has marked that as WONTFIX.

> 
> The test are not run at build time, is there a reason ( like "it need
> network" ) ?
> 
> 
> The package is also not installable on f17, so I didn't test it yet, and
> there is various maven related issue, and for that, i need to read and
> digest the java /maven policy. 
> 
We're most likely switching to packaging Leiningen 2, which does not need Maven. Hang on tight and I'll update this once I have a package to test.

Thanks!
Comment 6 Michel Alexandre Salim 2012-08-20 01:46:31 EDT
OK, apologies for the belated update. Looks like the Maven changes we need are doable, and Leiningen 2 carries a lot of additional dependencies so we'll just postpone that switch.

There are test packages for Rawhide here:
http://hircus.multics.org/yum-repos/leiningen-rawhide.repo
http://hircus.multics.org/yum-repos/leiningen/rawhide/

And the SRPM and spec have been updated:

http://salimma.fedorapeople.org/specs/clojure/leiningen.spec
http://salimma.fedorapeople.org/specs/clojure/leiningen-1.7.1-3.fc19.src.rpm
http://salimma.fedorapeople.org/specs/clojure/leiningen-1.7.1-3.fc19.noarch.rpm

They can be rebuilt or installed on the Fedora 18 branch as well, but there is no pre-built Mock profile for F18 yet. On F17, the new Maven changes have not been applied yet so I'll be in touch with the maven2 maintainer to see if he wants to update the F17 maven to match F18/Rawhide, or I would need to rework the Maven2 and Leiningen patches.

PS assigning the status to ASSIGNED instead of NEW, since you already set the fedora review flag. Thanks!
Comment 7 Michael Scherer 2012-08-20 12:05:08 EDT
Ok after checking the policy and the new spec, the maven/java related stuff from the review are fixed. Let me just build it to see if it work fine on F18.
Comment 8 Michael Scherer 2012-08-20 12:17:21 EDT
I cannot build it on f18 , no maven-artifact in mock.
Comment 9 Michel Alexandre Salim 2012-09-16 02:11:33 EDT
Sorry for the delay!

The new maven2 (with maven-artifact and maven-settings) is currently being pushed to stable updates:
https://admin.fedoraproject.org/updates/FEDORA-2012-12314/maven2-2.2.1-37.fc18

Meanwhile, it's now been added as a buildroot override, so you should be able to build Leiningen in Mock

https://admin.fedoraproject.org/updates/override/edit?build=maven2-2.2.1-37.fc18

(or just download it and manually install it into the mock instance before then building Leiningen -- let me know if you need assistance)
Comment 10 Michel Alexandre Salim 2012-09-21 23:31:29 EDT
Dependencies have landed; checked that mock -r fedora-18-x86_64 leiningen-1.7.1-3.fc19.src.rpm works

Let me know when you can do the review? It'd be great to have this done soon. Thanks!
Comment 11 Michael Scherer 2012-09-23 10:28:38 EDT
If it build, then that should be ok.
Comment 12 Michel Alexandre Salim 2012-09-24 11:25:16 EDT
Super, thanks!

New Package SCM Request
=======================
Package Name: leiningen
Short Description: Clojure project automation tool
Owners: salimma
Branches: f18
InitialCC:
Comment 13 Jon Ciesla 2012-09-24 11:33:56 EDT
Git done (by process-git-requests).
Comment 14 Fedora Update System 2012-10-16 05:27:13 EDT
leiningen-1.7.1-4.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/leiningen-1.7.1-4.fc18
Comment 15 Fedora Update System 2012-10-16 13:39:13 EDT
leiningen-1.7.1-4.fc18 has been pushed to the Fedora 18 testing repository.
Comment 16 Fedora Update System 2012-12-20 11:04:57 EST
leiningen-1.7.1-4.fc18 has been pushed to the Fedora 18 stable repository.

Note You need to log in before you can comment on or make changes to this bug.